#!/usr/bin/env node
'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var args = require('meow')('\n    Usage\n      $ nanopos [options]\n\n    Options\n      -c, --charge-url <url>      lightning charge server url [default: http://localhost:9112]\n      -t, --charge-token <token>  lightning charge access token [required]\n\n      -y, --items-path <path>     path to yaml file with item config [default: ./items.yaml, file is required]\n      -x, --currency <currency>   currency to use for item prices [default: BTC]\n      -m, --theme <name>          pick theme from bootswatch.com [default: yeti]\n      -l, --title <name>          website title [default: Lightning Nano POS]\n      --no-custom                 disable custom amount field [default: false]\n      --show-bolt11               display bolt11 as text and button [default: false]\n\n      -p, --port <port>           http server port [default: 9115]\n      -i, --host <host>           http server listen address [default: 127.0.0.1]\n      -h, --help                  output usage information\n      -v, --version               output version number\n\n    Example\n      $ nanopos -t chargeSecretToken -x EUR -y items.yaml\n\n', { flags: { chargeUrl: { alias: 'c' }, chargeToken: { alias: 't' },
    itemsPath: { alias: 'y' }, currency: { alias: 'x' }, theme: { alias: 'm' }, title: { alias: 'l' },
    port: { alias: 'p' }, host: { alias: 'i' } } }).flags;

Object.keys(args).filter(function (k) {
  return k.length > 1;
}).map(function (k) {
  return [k.replace(/([A-Z])/g, '_$1').toUpperCase(), args[k]];
}).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      k = _ref2[0],
      v = _ref2[1];

  return v !== false ? process.env[k] = v : process.env['NO_' + k] = true;
});

process.env.NODE_ENV || (process.env.NODE_ENV = 'production');

require('babel-polyfill');
require('./app');