'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

require('babel-polyfill');

var $ = require('jquery'),
    qrcode = require('qrcode');

require('popper.js');
require('bootstrap');

var payDialog = require('../views/payment.pug'),
    paidDialog = require('../views/success.pug');

var csrf = $('meta[name=csrf]').attr('content'),
    show_bolt11 = !!$('meta[name=show-bolt11]').attr('content');

$('[data-buy-item]').click(function (e) {
  e.preventDefault();
  pay({ item: $(e.target).data('buy-item') });
});
$('[data-buy]').submit(function (e) {
  e.preventDefault();
  pay({ amount: $(e.target).find('[name=amount]').val() });
});

var pay = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(data) {
    var inv, qr, diag, unlisten;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            $('[data-buy-item], [data-buy] :input').prop('disabled', true);

            _context.prev = 1;
            _context.next = 4;
            return $.post('invoice', _extends({}, data, { _csrf: csrf }));

          case 4:
            inv = _context.sent;
            _context.next = 7;
            return qrcode.toDataURL(('lightning:' + inv.payreq).toUpperCase(), { margin: 2, width: 300 });

          case 7:
            qr = _context.sent;
            diag = $(payDialog(_extends({}, inv, { qr: qr, show_bolt11: show_bolt11 }))).modal();


            updateExp(diag.find('[data-countdown-to]'));

            unlisten = listen(inv.id, function (paid) {
              return diag.modal('hide'), paid && success();
            });

            diag.on('hidden.bs.modal', function (_) {
              unlisten();
              $('[data-buy] :input').val('');
            });

          case 12:
            _context.prev = 12;
            $(':disabled').attr('disabled', false);return _context.finish(12);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1,, 12, 15]]);
  }));

  return function pay(_x) {
    return _ref.apply(this, arguments);
  };
}();

var listen = function listen(invid, cb) {
  var retry = function retry(_) {
    return listen(invid, cb);
  };
  var req = $.get('invoice/' + invid + '/wait');

  req.then(function (_) {
    return cb(true);
  }).catch(function (err) {
    return err.status === 402 ? retry() // long polling timed out, invoice is still payable
    : err.status === 410 ? cb(false) // invoice expired and can no longer be paid
    : err.statusText === 'abort' ? null // user aborted, do nothing
    : setTimeout(retry, 10000);
  }); // unknown error, re-poll after delay

  return function (_) {
    return retry = function retry(_) {
      return null;
    }, req.abort();
  };
};

var success = function success(_) {
  var diag = $(paidDialog()).modal();
  setTimeout(function (_) {
    return diag.modal('hide');
  }, 5000);
};

var updateExp = function updateExp(el) {
  var left = +el.data('countdown-to') - (Date.now() / 1000 | 0);
  if (left > 0) el.text(formatDur(left));else el.closest('.modal').modal('hide');
};

var formatDur = function formatDur(x) {
  var h = x / 3600 | 0,
      m = x % 3600 / 60 | 0,
      s = x % 60;
  return '' + (h > 0 ? h + ':' : '') + (m < 10 && h > 0 ? '0' : '') + m + ':' + (s < 10 ? '0' : '') + s;
};

setInterval(function (_) {
  return $('[data-countdown-to]').each(function (_, el) {
    return updateExp($(el));
  });
}, 1000);

$(document).on('hidden.bs.modal', '.modal', function (e) {
  return $(e.target).remove();
});