'use strict';

var _currencyFormatter = require('currency-formatter');

var _currencyFormatter2 = _interopRequireDefault(_currencyFormatter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var pwrap = function pwrap(fn) {
  return function (req, res, next) {
    return fn(req, res).catch(next);
  };
};

var fiatFormatter = function fiatFormatter(currency) {
  return function (amount) {
    return _currencyFormatter2.default.format(amount, { code: currency.toUpperCase() });
  };
};

module.exports = { pwrap: pwrap, fiatFormatter: fiatFormatter };